/**
 *
 * Copyright (c) 2001, Frank Bu
 *
 * project: LSystem
 * modul:   Test
 * version: $Revision: 1.12 $ $Name:  $
 *
 * Hauptprogramm zum Ausfhren aller definierten CppUnit Testflle.
 */

#include <windows.h>
#include <iostream>
#include <ctime>

#include "TextTestResult.h"

#include "test.h"
#include "TestFormula/TestFormula.h"

using namespace std;


#include <crtdbg.h>

_CrtMemState state;
char g_pTempPath[_MAX_PATH];


/**
 * Anzahl der aktuell auf dem Heap alloziierten Bytes zurckgeben.
 */
long getUsedMem()
{
    _CrtMemCheckpoint(&state);
    return state.lSizes[_NORMAL_BLOCK];
}


void delTemp()
{
	OSVERSIONINFO osv;
	memset(&osv, 0, sizeof(OSVERSIONINFO));
	osv.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osv);
	if (osv.dwPlatformId == VER_PLATFORM_WIN32_NT)
	{
		// Windows NT/2000, Whistler
		system((string("rmdir /s /q ") + string(g_pTempPath) + string(" > nul 2>&1")).c_str());
	} else
	{
		// Win32s, Windows 95/98/Me
		system((string("deltree /y ") + string(g_pTempPath)).c_str());
	}

	// Betriebssysteminformationen ausgeben
	printf("dwPlatformId: ");
	switch (osv.dwPlatformId) {
		case VER_PLATFORM_WIN32s:
			printf("Win32s on Windows 3.1.");
			break;
		case VER_PLATFORM_WIN32_WINDOWS:
			printf("Win32 on Windows 95 or Windows 98.");
			break;
		case VER_PLATFORM_WIN32_NT:
			printf("Win32 on Windows NT/Windows 2000.");
			break;
		default:
			printf("unknown: %i", osv.dwPlatformId);
	}
	printf("\ndwBuildNumber: %i\ndwMajorVersion: %i\ndwMinorVersion: %i\nszCSDVersion: %s\n", osv.dwBuildNumber, osv.dwMajorVersion, osv.dwMinorVersion, osv.szCSDVersion);
}


int main(int argc, char **argv)
{
	// temporres Verzeichnis erzeugen (vorher ggf. altes lschen
	GetTempPath(_MAX_PATH, g_pTempPath);
	strcat(g_pTempPath, "wftmpdir.tst");
	printf("TempPath: %s\n", g_pTempPath);
	delTemp();
	CreateDirectory(g_pTempPath, NULL);

    // Heap-Meldungen auf stdout
    _CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_FILE);
    _CrtSetReportFile(_CRT_WARN, _CRTDBG_FILE_STDOUT);
    _CrtSetReportMode(_CRT_ERROR, _CRTDBG_MODE_FILE);
    _CrtSetReportFile(_CRT_ERROR, _CRTDBG_FILE_STDOUT);
    _CrtSetReportMode(_CRT_ASSERT, _CRTDBG_MODE_FILE);
    _CrtSetReportFile(_CRT_ASSERT, _CRTDBG_FILE_STDOUT);

    // Memory-Leaks beim Programmende testen
    _CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG));

    // Tests hinzufgen
	TestSuite testSuite("TestAll");

    testSuite.addTest(TestFormula::suite());

    TextTestResult  result;

    time_t t1, t2;
    time(&t1);
	try {
		testSuite.run (&result);
		cout << result << endl;
	} catch (exception *exc) {
		printf("Exception: %s\n", exc->what());
		delete exc;
	}
    time(&t2);

    cout << "Laufzeit in Sekunden: " << t2 - t1 << endl;

    return 0;
}
